from datetime import datetime
from typing import List

from pydantic import BaseModel

from empire.server.api.v2.shared_dto import Author


def domain_to_dto_bypass(bypass):
    return Bypass(
        id=bypass.id,
        name=bypass.name,
        authors=bypass.authors or [],
        language=bypass.language,
        code=bypass.code,
        created_at=bypass.created_at,
        updated_at=bypass.updated_at,
    )


class Bypass(BaseModel):
    id: int
    name: str
    authors: List[Author]
    language: str
    code: str
    created_at: datetime
    updated_at: datetime


class Bypasses(BaseModel):
    records: List[Bypass]


class BypassUpdateRequest(BaseModel):
    name: str
    language: str
    code: str


class BypassPostRequest(BaseModel):
    name: str
    language: str
    code: str
